
/**
   Implement this task graph using four threads
   and fork/join. This will not deadlock.

              task1
             /     \
            /       \
       task2         task3
            \       /
             \     /
              task4
*/
public class TaskGraph_v0
{
   public static void main(String[] args) throws InterruptedException
   {
      final Task<Integer,Integer> task1 = new Task<>(1, 1, 2);
      final Task<Integer,Integer> task2 = new Task<>(2, 2, 1);
      final Task<Integer,Integer> task3 = new Task<>(3, 3, 3);
      final Task<Integer,Integer> task4 = new Task<>(4, 4, 2);

      final Thread t1 = new Thread(task1);
      final Thread t2 = new Thread(task2);
      final Thread t3 = new Thread(task3);
      final Thread t4 = new Thread(task4);

      // Here is a fork/join schedule for the task graph.
      t1.start();
      t1.join();
      t2.start();
      t3.start();
      t2.join();
      t3.join();
      t4.start();
      t4.join();
   }
}
