
/**
   Implement this task graph using four threads
   and fork/join, with the forks and joins inside
   of the thread tasks. This will not deadlock
   (but it does have a race condition).

              task1
             /     \
            /       \
       task2         task3
            \       /
             \     /
              task4
*/
public class TaskGraph_v1
{
   public static void main(String[] args)
   {
      final Task<Integer,Integer> task1 = new Task<>(1, 1, 2);
      final Task<Integer,Integer> task2 = new Task<>(2, 2, 1);
      final Task<Integer,Integer> task3 = new Task<>(3, 3, 3);
      final Task<Integer,Integer> task4 = new Task<>(4, 4, 2);

      final Thread t4 = new Thread(task4);

      final Thread t3 = new Thread(task3);

      final Thread t2 = new Thread(
                          ()->{try{ task2.run();
                                    t3.join();  // join (maybe!)
                                    t4.start(); // fork
                                  }catch(InterruptedException e){} }
                                  );

      final Thread t1 = new Thread(
                          ()->{ task1.run();
                                t2.start();     // fork
                                t3.start(); }   // fork
                                  );
      t1.start(); // fork
   }
}
